#include <fstream.h>
#include <stream.h>
#include "Vector.h"
#include "types.h"
#include "ValueType.h"
#include "PasNode.h"
#include <FlexLexer.h>
#include "PascalLexer.h"
#include "VarTable.h"
#include "Compiler.h"

int yyparse();
Compiler *compiler;

void Compiler::yyerror(char *s){
  cerr<<lexer->getFilename()<<lexer->lineno()<<": "<<s<<" before ";
  cerr<<"\""<<lexer->getText()<<"\""<<endl;
  errCount++;
}
void Compiler::yyerrorShort(){
  cerr<<lexer->getFilename()<<lexer->lineno()<<": ";
  errCount++;
}
void Compiler::error(){
  errCount++;
}
void Compiler::genError(char *s){
  cerr<<"Generate error: "<<s<<endl;
}
Compiler::Compiler(char *filename){
  global=new VarTable();
  local=NULL;
  ifstream *vstup=new ifstream();
  vstup->open(filename,ios::in);
  lexer = new PascalLexer(vstup,filename);
  errCount=0;
  program=NULL;
}

void Compiler::generate(){
  if(program!=NULL){
     program->generate();
  }
}



int main(int argc,char **argv){
  if(argc<2){
    cerr<<"Malo parametru"<<endl;
    return -1;
  }
  else {
    compiler = new Compiler(argv[1]);
  }
  yyparse();
  if(compiler->getErrCount()>0){
    cerr<<compiler->getLexer()->getFilename()<<" Compilation ends with ";
    cerr<<compiler->getErrCount()<<" errors"<<endl;
    exit(-1);
  }
  compiler->generate();
}

