class WriteCallNode:public CallNode{
  public:
    WriteCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};
class WritelnCallNode:public WriteCallNode{
  public:
    WritelnCallNode(ProcedureNode *proc, RealParametersNode *param):
                WriteCallNode(proc,param){
    }
    virtual void generate();
};

class WriteProc:public ProcedureNode{
  private:
  public:
  WriteProc():ProcedureNode(PROCTYP, VTYP,"write",NULL,NULL){
  }
  void generatePrint(int typ);
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};
class WritelnProc:public WriteProc{
  public:
    WritelnProc():WriteProc(){
      name="writeln";
    }
    virtual void generateReturn();
    virtual void generate();
    virtual void generateCall(RealParametersNode *real);
    virtual CallNode *construct(RealParametersNode *param);
};
class LengthProc:public ProcedureNode{
  public:
  LengthProc():ProcedureNode(FUNCTYP, ITYP,"length",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class LengthCallNode:public CallNode{
  public:
    LengthCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};

class ReadIntProc:public ProcedureNode{
  public:
  ReadIntProc():ProcedureNode(FUNCTYP, ITYP,"readint",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class ReadIntCallNode:public CallNode{
  public:
    ReadIntCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};
class ReadCharProc:public ProcedureNode{
  public:
  ReadCharProc():ProcedureNode(FUNCTYP, CTYP,"readchar",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class ReadCharCallNode:public CallNode{
  public:
    ReadCharCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};

class ReadBooleanProc:public ProcedureNode{
  public:
  ReadBooleanProc():ProcedureNode(FUNCTYP, BTYP,"readboolean",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class ReadBooleanCallNode:public CallNode{
  public:
    ReadBooleanCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};
class ReadStringProc:public ProcedureNode{
  public:
  ReadStringProc():ProcedureNode(FUNCTYP, STYP,"readstring",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class ReadStringCallNode:public CallNode{
  public:
    ReadStringCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};
class EofProc:public ProcedureNode{
  public:
  EofProc():ProcedureNode(FUNCTYP, BTYP,"eof",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class EofCallNode:public CallNode{
  public:
    EofCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};
class ValProc:public ProcedureNode{
  public:
  ValProc():ProcedureNode(FUNCTYP, ITYP,"val",NULL,NULL){
  }
  virtual int compatible(RealParametersNode *real);
  virtual void generateReturn();
  virtual void generate();
  virtual void generateCall(RealParametersNode *real);
  virtual CallNode *construct(RealParametersNode *param);
};

class ValCallNode:public CallNode{
  public:
    ValCallNode(ProcedureNode *proc, RealParametersNode *param):
		CallNode(proc,param,NULL){
    }
    virtual int getStackSize();
    virtual void generate();
};
