// Soubor: Table.h
// Popis:  Definice rozhran generick tabulky ukazatel
// Autor:  benes@dcse.fee.vutbr.cz (Miroslav Benes)
// Datum:  19/11/97

# ifndef _TABLE_H_
# define _TABLE_H_
# include <assert.h>

template<class T>
class Table {
public:
   Table(unsigned short aCount = 10, unsigned short aStep = 10);
   unsigned short getCount() { return count; }
   void insertLast(T* cp);
   void alloc(unsigned short aCount);
   T* operator [](unsigned short index);
   void destroyAll();
   
private:
   unsigned short count;
   unsigned short size;
   unsigned short step;
   T**				ptrs;
}; // Table

template<class T>
Table<T>::Table(unsigned short aCount, unsigned short aStep)
{
   count = 0;
   size = aCount;
   step = aStep;
   if( aCount > 0 )
      ptrs = new T*[aCount];
   else
      ptrs = 0;
} // Table<T>::Table

template<class T>
void Table<T>::alloc(unsigned short aCount)
{
   if( aCount > size ) {
      T** newPtrs = new T*[aCount];
      memcpy(newPtrs, ptrs, size * sizeof(T*));
      delete ptrs;
      ptrs = newPtrs;
      size = aCount;
   }
} // Table<T>::alloc

template<class T>
T* Table<T>::operator [](unsigned short index)
{
   assert(index < size);
   return ptrs[index];
} // Table<T>::operator []

template<class T>
void Table<T>::insertLast(T* ptr)
{
   if( count >= size ) 
      alloc(size + step);
   
   ptrs[count++] = ptr;
} // Table<T>::insertLast

template<class T>
void Table<T>::destroyAll()
{
   while( count > 0 ) {
      delete ptrs[--count];
   }
} // Table<T>::destroy

# endif
