%option noyywrap
%option C++
%option yylineno
%option yyclass="PascalLexer"
%{
#define TRUE 1
#define FALSE 0
#define YYSTYPE AtribVal
#include <stream.h>
#include <fstream.h>
#include <string.h>
#include <ctype.h>
#include "types.h"
#include "Vector.h"
#include "ValueType.h"
#include "PasNode.h"
#include "AtribVal.h"
#include "PascalLexer.h"
#include "parser.h"
#include "Compiler.h"

const char *Compiler::pripona=".pas";
extern Compiler *compiler;
%}
wspace [ \t\n\r\v]
pozn "(""*"(([^)]|\n|([^*]")"))*)"*"")"
unterm_pozn "(""*"(([^)]|\n|([^*]")"))*)
letter [a-zA-Z]
digit [0-9]
ident {letter}({letter}|{digit})*
op_plus "+"
op_minus "-"
op_krat "*"
op_deleno "/"
op_mod (M|m)(O|o)(D|d)
op_div (D|d)(I|i)(V|v)
op_not (N|n)(O|o)(T|t)
op_and (A|a)(N|n)(D|d)
op_or  (O|o)(R|r)
ks_array (A|a)(R|r)(R|r)(A|a)(Y|y)
ks_begin (B|b)(E|e)(G|g)(I|i)(N|n)
ks_break (B|b)(R|r)(E|e)(A|a)(K|k)
ks_Boolean (B|b)(O|o)(O|o)(L|l)(E|e)(A|a)(N|n)
ks_Char (C|c)(H|h)(A|a)(R|r)
ks_do (D|d)(O|o)
ks_else (E|e)(L|l)(S|s)(E|e)
ks_end (E|e)(N|n)(D|d)
ks_False (F|f)(A|a)(L|l)(S|s)(E|e)
ks_function (F|f)(U|u)(N|n)(C|c)(T|t)(I|i)(O|o)(N|n)
ks_if (I|i)(F|f)
ks_Integer (I|i)(N|n)(T|t)(E|e)(G|g)(E|e)(R|r)
ks_of (O|o)(F|f)
ks_procedure (P|p)(R|r)(O|o)(C|c)(E|e)(D|d)(U|u)(R|r)(E|e)
ks_program (P|p)(R|r)(O|o)(G|g)(R|r)(A|a)(M|m)
ks_return (R|r)(E|e)(T|t)(U|u)(R|r)(N|n)
ks_String (S|s)(T|t)(R|r)(I|i)(N|n)(G|g)
ks_then (T|t)(H|h)(E|e)(N|n)
ks_True (T|t)(R|r)(U|u)(E|e)
ks_while (W|w)(H|h)(I|i)(L|l)(E|e)
ks_var (V|v)(A|a)(R|r)
rozsah "\.\."
strednik ;
dvojtecka :
tecka \. 
carka ,
rovnitko =
mensi <
vetsi >
mensi_rovno "<="
vetsi_rovno ">="
nerovno "<>"
prirazeni ":="
lzavorka \(
pzavorka \)
lindex "["
pindex "]"
cislo {digit}+
/*bad_cislo {digit}+[A-Za-z]*{digit}* */
znak (\'[^']\')|(\'\'\'\')
string \'([^']|(\'\'))*\'
unterm_string \'([^']|(\'\'))*
zbytek .
%%
{wspace}	;
{pozn}		;
{unterm_pozn}	{
		 cerr<< filename << (yylineno-radek());
		 cerr<<": unterminated comment"<<endl;
                 compiler->error();
		}
{znak}		{
		 yylval.charVal=yytext[1];
		 return ZNAK;}
{string}	{char* ret = new char[yyleng];
		 mstrcpy(ret,yytext+1);
		 yylval.strVal=ret;
		 return STRING;}
{unterm_string}	{
		 cerr<< filename <<yylineno;
		 cerr<<": unterminated string or character constant"<<endl;
		 cerr<< filename <<(yylineno-radek());
		 cerr<<": posible real start of unterminated constant"<<endl;
                 compiler->error();
		}
{ks_array}	return KS_ARRAY;
{ks_begin}	return KS_BEGIN;
{ks_break}	return KS_BREAK;
{ks_Boolean}	return KS_BOOLEAN;
{ks_Char}	return KS_CHAR;
{ks_do}		return KS_DO;
{ks_else}	return KS_ELSE;
{ks_end}	return KS_END;
{ks_False}	{
		 yylval.boolVal=0;
		 return BOOL_CONST;
		}
{ks_function}	return KS_FUNCTION;
{ks_if}		return KS_IF;
{ks_Integer}	return KS_INTEGER;
{ks_of}		return KS_OF;
{ks_procedure}	return KS_PROCEDURE;
{ks_program}	return KS_PROGRAM;
{ks_return}	return KS_RETURN;
{ks_String}	return KS_STRING;
{ks_then}	return KS_THEN;
{ks_True}	{	
		 yylval.boolVal=1;
		 return BOOL_CONST;
		}
{ks_var}	return KS_VAR;
{ks_while}	return KS_WHILE;
{op_krat}	{ 
		 yylval.operType=KRAT;
		 return MULL_OPER;
		}
{op_deleno}	{
		 yylval.operType=DELENO;
		 return MULL_OPER;
		}
{op_minus}	{
		 yylval.operType=MINUS;
		 return MINUS_OPER;
		}
{op_plus}	{
		 yylval.operType=PLUS;
		 return ADD_OPER;
		}
{op_div}	{
		 yylval.operType=DIV;
		 return MULL_OPER;
		}
{op_mod}	{
		 yylval.operType=MOD;
		 return MULL_OPER;
		}
{op_or}		{
		 yylval.operType=OR;
		 return ADD_OPER;
		}
{op_and}	{
		 yylval.operType=AND;
		 return MULL_OPER;
		}
{op_not}	{
		 yylval.operType=NOT;
		 return NOT_OPER;
                }
{ident} 	{
		 char *n=new char[strlen(yytext)+1];	
		 strcpy(n,yytext);
		 yylval.name=n;
		 return IDENT;}
{strednik}	return STREDNIK;
{lzavorka}	return LZAVORKA;
{pzavorka}	return PZAVORKA;
{carka}		return CARKA;
{rovnitko}	{
		 yylval.operType=EQ;
		 return REL_OPER;
		}
{rozsah}	return ROZSAH;
{dvojtecka}	return DVOJTECKA;
{tecka}		return TECKA;
{mensi}		{
		 yylval.operType=LESS;
		 return REL_OPER;
		}
{vetsi}		{
		 yylval.operType=GREATER;
		 return REL_OPER;
		}
{mensi_rovno}	{
		 yylval.operType=LESSEQ;
		 return REL_OPER;
		}
{vetsi_rovno}	{
		 yylval.operType=GREATEREQ;
		 return REL_OPER;
		}
{nerovno}	{
		 yylval.operType=NOEQ;
		 return REL_OPER;
		}
{prirazeni}	return PRIRAZENI;
{lindex}	return LINDEX;
{pindex}	return PINDEX;
{cislo}		{
		 int cislo;
		 cislo = atoi(yytext);
		 yylval.intVal=cislo;
		 return CISLO;}
{zbytek}	{
		 cerr <<  filename <<yylineno << ": ";
		 cerr << "unexpected character '" << yytext; 
		 cerr << "'" << endl;
                 compiler->error();
		}
%%
char* PascalLexer::mstrcpy(char* cil,char* zdroj){
  int i=0;
  int j=0;
  while(zdroj[i]!='\0'){
    if(zdroj[i]!='\''){
      cil[j]=zdroj[i];
      i++;
      j++;
    }
    else {
      if(zdroj[i+1]='\''){
        cil[j]=zdroj[i];
        i+=2;
        j++;
      }
      else {
        cil[j]=zdroj[i];
        i++;
        j++;
      }
    }
  }
  cil[j-1]='\0';
  return cil;
}

PascalLexer::PascalLexer(istream *vstup,char *fname):yyFlexLexer(vstup){
  char *pripona=rindex(fname,'.');
  if(pripona==NULL){
    cerr<<"Name of file must end with \""<<Compiler::pripona<<"\""<<endl;
    exit(-1);
  }
  if(strcmp(pripona,Compiler::pripona)!=0){
    cerr<<"Name of file must end with \""<<Compiler::pripona<<"\""<<endl;
    exit(-1);
  }
  filenameShort=new char[pripona-fname+1];
  strncpy(filenameShort,fname,pripona-fname);
  int i =strlen(fname);
  filename = new char[i+2];
  strcpy(filename,fname);
  filename[i] = ':';
  filename[i+1] = '\0';
}


int PascalLexer::radek(void){
  int iii=0;
  int j;
  for(j=0;yytext[j]!=0;j++){
    if(yytext[j]=='\n'){
      iii++;
    }
  }
  return iii;
}
